//+------------------------------------------------------------------+
//|                                                    WPR Bands.mq4 |
//|                                                      cja 11/2012 |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_level1 0
#property indicator_level2 -50
#property indicator_level3 -100
#property indicator_levelcolor DarkSlateGray


#property indicator_color1 Gold
#property indicator_color2 Gold
#property indicator_color3 DarkOrange
#property indicator_color4 Red
#property indicator_width4 3

extern int      WPRPeriod          = 55;
extern int      SmoothPeriod       = 30;
extern int      SmoothMethod       = 0; 

extern int      BandsPeriod        = 55;
extern double   BandsDeviation     = 2;
extern int      BandsShift         = 0;

double wpr1[];
double wpr2[];
double bnd1[];
double bnd2[];
double bnd3[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   IndicatorBuffers(5);
    
   
   SetIndexDrawBegin(0,BandsPeriod);
   SetIndexDrawBegin(1,BandsPeriod);
   SetIndexDrawBegin(2,BandsPeriod);
   SetIndexDrawBegin(3,SmoothPeriod);
   SetIndexDrawBegin(4,WPRPeriod);
   
   
   
   SetIndexBuffer(0,bnd1);
   SetIndexBuffer(1,bnd2);
   SetIndexBuffer(2,bnd3);
   SetIndexBuffer(3,wpr2);
   SetIndexBuffer(4,wpr1);
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_NONE);
   
   IndicatorDigits(2);
   IndicatorShortName("WPR Bands");
     
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  
  return(0);
  }
//+------------------------------------------------------------------+
//| Ticks Volume Indicator                                           |
//+------------------------------------------------------------------+
int start()
  {
   
   int i,counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   
//----
   for(i=limit; i>=0; i--)
     {
     wpr1[i] = iWPR(NULL,0,WPRPeriod,i);
     }
   for(i=limit; i>=0; i--)
     {
     wpr2[i] = iMAOnArray(wpr1,0,SmoothPeriod,0,SmoothMethod,i);
     }
   for(i=limit; i>=0; i--)
     {
     bnd1[i] = iBandsOnArray(wpr2,0,BandsPeriod,BandsDeviation,BandsShift,MODE_LOWER,i);
     bnd2[i] = iBandsOnArray(wpr2,0,BandsPeriod,BandsDeviation,BandsShift,MODE_UPPER,i);
     bnd3[i] = iBandsOnArray(wpr2,0,BandsPeriod,BandsDeviation,BandsShift,MODE_MAIN,i);
     }

//----
   return(0);
  }

//+------------------------------------------------------------------+    